def find_median(array):
  return find_statistic(array,len(array)/2,0,len(array))

def find_statistic(array,k,start,finish):
  if finish-start<=5:
    copy=sorted(array[start:finish])
    return copy[k]
  small_array=[median5(array,start+5*i,finish) \
                 for i in range((finish-start+4)/5)]
  approx_median=find_median(small_array)
  pos=sort_pass(array,start,finish,approx_median)
  if k<pos:
    return find_statistic(array,k,start,start+pos)
  else:
    return find_statistic(array,k-pos,start+pos,finish)

def sort_pass(array,start,finish,approx_median):
  p1=start
  p2=finish-1
  while p1!=p2:
    while p1<p2 and array[p1]<approx_median:
      p1+=1
    while p1<p2 and array[p2]>=approx_median:
      p2-=1
    if p1!=p2:
      temp=array[p1]
      array[p1]=array[p2]
      array[p2]=temp
      p1+=1
      if p1<p2:
        p2-=1
  if array[p1]<approx_median:
    p1+=1
  return p1-start

def median5(array,start,finish):
  length=min(5,finish-start)
  copy=sorted(array[start:start+length])
  return copy[length/2]
